#cython: language_level=3

'''
Created on 25 mars 2016

@author: coissac
'''

import re

__ret__         = re.compile('''(([^ ]+)=('[^']*'|"[^"]*"|[^;]+); *)+?''')
__re_int__      = re.compile("^[+-]?[0-9]+$")
__re_float__    = re.compile("^[+-]?[0-9]+(\.[0-9]*)?([eE][+-]?[0-9]+)?$")
__re_str__      = re.compile("""^"[^"]*"|'[^']*'$""")
__re_dict__     = re.compile("""^\{\ *
                                   (
                                       ("[^"]*"|'[^']*')
                                        \ *:\ *
                                       ([^,}]+|
                                        "[^"]*"|
                                        '[^']*'
                                       )
                                   )?
                                   (\ *,\ *
                                       ("[^"]*"|'[^']*')
                                        \ *:\ *
                                       ([^,}]+|
                                        "[^"]*"|
                                        '[^']*'
                                       )
                                    )*\ *\}$""", re.VERBOSE)

__re_val__ = re.compile("""(("[^"]*"|'[^']*') *: *([^,}]+|"[^"]*"|'[^']*') *[,}] *)""")

cdef object __etag__(str x):
    cdef list elements
    cdef tuple i
    
    if __re_int__.match(x):
        v=int(x)
    elif __re_float__.match(x):
        v=float(x)
    elif __re_str__.match(x):
        v=x[1:-1]
    elif x=='None':
        v=None
    elif x=='False':
        v=False
    elif x=='True':
        v=True
    elif __re_dict__.match(x):
        elements=__re_val__.findall(x)
        v=dict([(i[1][1:-1],__etag__(i[2])) for i in elements])
    else:
        v=x
    return v

cpdef tuple parseHeader(str header):
    cdef list m 
    cdef dict tags 
    cdef str definition
    cdef str ident
    cdef str second
    
    m=header[1:-1].split(maxsplit=1)
   
    ident=m[0]
    
    if len(m)==1:
        tags={}
        definition='' 
    else:
        second=m[1]
        m = __ret__.findall(second)
        
        if m:
            tags = dict([(a[1],__etag__(a[2])) for a in m])
            definition = second.split(m[-1][0],1)[1].strip()
        else:
            tags = {}
            definition = second.strip() 
        
    return ident,tags,definition
    

